﻿using System;
using System.Threading.Tasks;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        /// <returns>태스크</returns>
        private static async Task Main()
        {
            Console.Title = "Task 클래스 : 비동기 처리하기";

            Program program = new Program();

            await program.CallAsync();
        }

        #endregion

        #region 비동기 텍스트 구하기 - GetTextAsync()

        /// <summary>
        /// 비동기 텍스트 구하기
        /// </summary>
        /// <returns>문자열 태스크</returns>
        private async Task<string> GetTextAsync()
        {
            Task<string> task = new TaskFactory().StartNew(() => { return "TEST"; });

            string result = await task;

            return result;
        }

        #endregion
        #region 비동기 호출하기 - CallAsync()

        /// <summary>
        /// 비동기 호출하기
        /// </summary>
        /// <returns>태스크</returns>
        private async Task CallAsync()
        {
            string currentTime = DateTime.Now.ToString();

            string text = await GetTextAsync();

            Console.WriteLine(currentTime + " : " + text);
        }

        #endregion
    }
}